/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Context,
  Pda,
  PublicKey,
  Signer,
  TransactionBuilder,
  publicKey,
  transactionBuilder,
} from '@metaplex-foundation/umi';
import {
  Serializer,
  mapSerializer,
  struct,
  u8,
} from '@metaplex-foundation/umi/serializers';
import {
  ResolvedAccount,
  ResolvedAccountsWithIndices,
  getAccountMetasAndSigners,
} from '../shared';
import {
  MintPrintingTokensViaTokenArgs,
  MintPrintingTokensViaTokenArgsArgs,
  getMintPrintingTokensViaTokenArgsSerializer,
} from '../types';

// Accounts.
export type DeprecatedMintPrintingTokensInstructionAccounts = {
  /** Destination account */
  destination: PublicKey | Pda;
  /** Printing mint */
  printingMint: PublicKey | Pda;
  /** Update authority */
  updateAuthority: Signer;
  /** Metadata key (pda of ['metadata', program id, mint id]) */
  metadata: PublicKey | Pda;
  /** Master Edition V1 key (pda of ['metadata', program id, mint id, 'edition']) */
  masterEdition: PublicKey | Pda;
  /** Token program */
  tokenProgram?: PublicKey | Pda;
  /** Rent */
  rent?: PublicKey | Pda;
};

// Data.
export type DeprecatedMintPrintingTokensInstructionData = {
  discriminator: number;
  mintPrintingTokensViaTokenArgs: MintPrintingTokensViaTokenArgs;
};

export type DeprecatedMintPrintingTokensInstructionDataArgs = {
  mintPrintingTokensViaTokenArgs: MintPrintingTokensViaTokenArgsArgs;
};

export function getDeprecatedMintPrintingTokensInstructionDataSerializer(): Serializer<
  DeprecatedMintPrintingTokensInstructionDataArgs,
  DeprecatedMintPrintingTokensInstructionData
> {
  return mapSerializer<
    DeprecatedMintPrintingTokensInstructionDataArgs,
    any,
    DeprecatedMintPrintingTokensInstructionData
  >(
    struct<DeprecatedMintPrintingTokensInstructionData>(
      [
        ['discriminator', u8()],
        [
          'mintPrintingTokensViaTokenArgs',
          getMintPrintingTokensViaTokenArgsSerializer(),
        ],
      ],
      { description: 'DeprecatedMintPrintingTokensInstructionData' }
    ),
    (value) => ({ ...value, discriminator: 9 })
  ) as Serializer<
    DeprecatedMintPrintingTokensInstructionDataArgs,
    DeprecatedMintPrintingTokensInstructionData
  >;
}

// Args.
export type DeprecatedMintPrintingTokensInstructionArgs =
  DeprecatedMintPrintingTokensInstructionDataArgs;

// Instruction.
export function deprecatedMintPrintingTokens(
  context: Pick<Context, 'programs'>,
  input: DeprecatedMintPrintingTokensInstructionAccounts &
    DeprecatedMintPrintingTokensInstructionArgs
): TransactionBuilder {
  // Program ID.
  const programId = context.programs.getPublicKey(
    'mplTokenMetadata',
    'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'
  );

  // Accounts.
  const resolvedAccounts = {
    destination: {
      index: 0,
      isWritable: true as boolean,
      value: input.destination ?? null,
    },
    printingMint: {
      index: 1,
      isWritable: true as boolean,
      value: input.printingMint ?? null,
    },
    updateAuthority: {
      index: 2,
      isWritable: false as boolean,
      value: input.updateAuthority ?? null,
    },
    metadata: {
      index: 3,
      isWritable: false as boolean,
      value: input.metadata ?? null,
    },
    masterEdition: {
      index: 4,
      isWritable: false as boolean,
      value: input.masterEdition ?? null,
    },
    tokenProgram: {
      index: 5,
      isWritable: false as boolean,
      value: input.tokenProgram ?? null,
    },
    rent: { index: 6, isWritable: false as boolean, value: input.rent ?? null },
  } satisfies ResolvedAccountsWithIndices;

  // Arguments.
  const resolvedArgs: DeprecatedMintPrintingTokensInstructionArgs = {
    ...input,
  };

  // Default values.
  if (!resolvedAccounts.tokenProgram.value) {
    resolvedAccounts.tokenProgram.value = context.programs.getPublicKey(
      'splToken',
      'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'
    );
    resolvedAccounts.tokenProgram.isWritable = false;
  }
  if (!resolvedAccounts.rent.value) {
    resolvedAccounts.rent.value = publicKey(
      'SysvarRent111111111111111111111111111111111'
    );
  }

  // Accounts in order.
  const orderedAccounts: ResolvedAccount[] = Object.values(
    resolvedAccounts
  ).sort((a, b) => a.index - b.index);

  // Keys and Signers.
  const [keys, signers] = getAccountMetasAndSigners(
    orderedAccounts,
    'programId',
    programId
  );

  // Data.
  const data =
    getDeprecatedMintPrintingTokensInstructionDataSerializer().serialize(
      resolvedArgs as DeprecatedMintPrintingTokensInstructionDataArgs
    );

  // Bytes Created On Chain.
  const bytesCreatedOnChain = 0;

  return transactionBuilder([
    { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
  ]);
}
